package com.casic.dcms.mvp.model.impl;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.listener.OnActionResultListener;
import com.casic.dcms.mvp.model.IControlLightModel;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import java.util.List;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class ControlLightModelImpl implements IControlLightModel {

    private final OnActionResultListener actionResultListener;

    public ControlLightModelImpl(OnActionResultListener listener) {
        this.actionResultListener = listener;
    }

    /**
     * {@link com.casic.dcms.mvp.model.IControlLightModel}
     */
    @Override
    public Subscription sendControlLightRequest(List<Long> lampIds, String controlType) {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getLightControlResult(lampIds, controlType);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    actionResultListener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    actionResultListener.onSuccess(resultBean);
                }
            }
        });
    }
}
